# coding: utf-8

# Importation du module graphique
import matplotlib.pyplot as plt
import numpy as np


### Equation du type aA + bB -> cC + dD

# Saisie par l'utilisateur des nombres stoechiométriques
print("Veuillez entrer les nombres stœchiométriques de l'équation chimique")
a = float(input('Réactif A :\n\t nombre stœchiométrique a = '))
b = float(input('Réactif B :\n\t nombre stœchiométrique b = '))
c = float(input('Produit C :\n\t nombre stœchiométrique c = '))
d = float(input('Produit D :\n\t nombre stœchiométrique d = '))


# Saisie par l'utilisateur des quantités initiales des réactifs et produits
print()
print("Veuillez saisir les quantités de matières de chacun des réactifs et produits en mole")
ni_A = float(input('Réactif A :\n\t n_i(A) = '))
ni_B = float(input('Réactif B :\n\t n_i(B) = '))
ni_C = float(input('Produit C :\n\t n_i(C) = '))
ni_D = float(input('Produit D :\n\t n_i(D) = '))


### Calcul de l'avancement maximal avec affichage de sa valeur et de l'espèce limitante
xA = ni_A / a
xB = ni_B / b
x_max = min(xA, xB)
print()
if xA < xB:
    print(f"Le réactif limitant est l'espèce A et l'avancement maximal a pour valeur {x_max} mol")
elif xA > xB:
    print(f"Le réactif limitant est l'espèce B et l'avancement maximal a pour valeur {x_max} mol")
else:
    print(f"Les réactifs sont dans les proportions stœchiométriques, l'avancement maximal a pour valeur {x_max} mol")


### Définition de l'état final
# Quantité finale de A
nf_A = ni_A - a*x_max
# Quantité finale de A
nf_B = ni_B - b*x_max
# Quantité finale de C
nf_C = ni_C + c*x_max
# Quantité finale de D
nf_D = ni_D + d*x_max
# Sortie utilisateur
print(f"À l'état final, les quantités de matières de chacunes des espèces sont les suivantes :\n"
      f"{nf_A} mol de A\n{nf_B} mol de B\n{nf_C} mol de C\n{nf_D} mol de D")



### Représentation graphique

# Définition des valeurs de x
x = np.arange(0, x_max, x_max / 100)

# Definition des grandeurs a representer
n_A = ni_A - a*x
n_B = ni_B - b*x
n_C = ni_C + c*x
n_D = ni_D + d*x

# Definition des courbes
plt.plot(x, n_A, label="Réactif A")
plt.plot(x, n_B, label="Réactif B")
plt.plot(x, n_C, label="Produit C")
plt.plot(x, n_D, label="Produit D")

# Réglages axes et grille
n_max = max(ni_A, ni_B, nf_C, nf_D)
plt.axis([0, x_max, 0, n_max])
plt.grid()

# Labels du graphique
plt.xlabel("Avancement (mol)")
plt.ylabel("Quantité de matière (mol)")
plt.title("Évolution des quantités de matières des réactifs et des produits")

# Création de l'image
nom_du_fichier = "courbes_avancement_" + str(ni_A) + "_" + str(ni_B)
plt.savefig(nom_du_fichier+".pdf", format='pdf', facecolor='0.8', edgecolor='w')

# Affichage de la légende et du graphique
plt.legend(loc='center left')
plt.show()